#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <assert.h>
#include <string.h>
#include "ant_tools.h"


int pheromons_evaporation(int current_level)
{
  return current_level-1;
}

void append_ant(int x, int y, int loaded )
{
  if(loaded){
    next_cellulae[xyTOid(x, y)].ant_loaded++;
    debug(" ant loaded moves in (%d ,%d) ", x, y);
  }
  else {
    debug(" ant seeking moves in (%d ,%d) ", x, y);
    next_cellulae[xyTOid(x, y)].ant_seeking++; 
  }
}

double distance(int xf, int yf, int x, int y)
{
  //  debug("source: ( %d %d ) ant: (%d %d)   d = %f ",
  //  xf, yf, x, y, sqrt( (x-xf) * (x-xf) + (y-yf) * (y-yf) ) );
  return sqrt( (x-xf) * (x-xf) + (y-yf) * (y-yf) );
}

void move_ant(int x, int y, enum direction dir, int loaded)
{
  switch(dir)
    {
    case DIR_STAY:
      append_ant(x, y, loaded);
      break;
    
    case DIR_EAST:
      if( (!eastest_rank) && (east_frontier) ){
	if (loaded){
	  ants_to_east[y].ant_loaded++;
	  ants_by_process--;
	  debug("ants_by_process = %d",ants_by_process);
	  debug("ants_to_east[%d].ant_loaded %d", y, ants_to_east[y].ant_loaded );
	}
	else{
	  ants_to_east[y].ant_seeking++;
	  ants_by_process--;
	  debug("ants_to_east[%d].ant_seeking %d", y, ants_to_east[y].ant_seeking );
	  debug("ants_by_process = %d",ants_by_process);
	}
      }
      else{
	append_ant(EAST(x, y), loaded);
      }
      break;
      
    case DIR_NORTH:
      append_ant(NORTH(x, y), loaded);
      break;
      
    case DIR_WEST:
      if( (!westest_rank) && (west_frontier) ){
	if (loaded){
	  ants_to_west[y].ant_loaded++;
	  debug("ant_to_west[%d] loaded %d", y, ants_to_west[y].ant_loaded);
	  ants_by_process--;
	  debug("ants_by_process = %d",ants_by_process);
	}
	else{
	  ants_to_west[y].ant_seeking++;
	  debug("ant_to_west[%d] seeking %d", y, ants_to_west[y].ant_seeking);
	  ants_by_process--;
	  debug("ants_by_process = %d",ants_by_process);
	}
      }
      else{
	append_ant(WEST(x, y), loaded);
      }	
      break;
      
    case DIR_SOUTH:
      append_ant(SOUTH(x, y), loaded);
      break;
    }
}

void back_home(int x, int y)
{
  enum direction dir = DIR_STAY;
  double d, d2;
  debug("home road (%d %d) evaluating ", x, y); 
  int x1;
  x1 = x + my_rank * width_info[my_rank];
  
  if (west_frontier && westest_rank) {
    d = upper_distance;
    debug("DIR_WEST %f max", d); 
  }
  else{
    d = distance(xFarm, yFarm, WEST(x1, y));
    debug("DIR_WEST %f", d); 
    dir = DIR_WEST;
  }
  
  if (!( east_frontier && eastest_rank)) {
    d2 = distance(xFarm, yFarm, EAST(x1, y));
    debug("DIR_EAST %f", d2) ;
    if( d2 < d )
      {
	d = d2;
	dir = DIR_EAST;
      }
  }
  
  if (!north_frontier) {
    d2 = distance(xFarm, yFarm, NORTH(x1, y));
    debug("DIR_NORTH %f", d2); 
    if( d2 < d ){
      d = d2;
      dir = DIR_NORTH;
    }
  }
  
  if (!south_frontier) {
    d2 = distance(xFarm, yFarm, SOUTH(x1, y));
    debug("DIR_SOUTH %f", d2);
    if( d2 < d )
      dir = DIR_SOUTH;
  }
  //print_dir(dir," dir chosen for going home");
  move_ant(x, y, dir, 1);
  
}

enum direction random_dir(void)
{
  return ( ( 1 + (int) (4.0*rand()/(RAND_MAX+1.0)) ) );
}

enum direction ant_out_antfarm(int xFarmLocal, int yFarmLocal)
{
  int id;
  
  if ( xFarmLocal != my_width-1 ){
    id = EAST_ID(xFarmLocal, yFarmLocal);
    if ( current_cellulae[id].pheromons_level > 0) return DIR_EAST;
  }
  
  if ( yFarmLocal != 0){
    id = NORTH_ID(xFarmLocal, yFarmLocal);
    if ( current_cellulae[id].pheromons_level > 0) return DIR_NORTH;
  }
  
  if( xFarm!=0 ){
    id = WEST_ID(xFarmLocal, yFarmLocal);
    if ( current_cellulae[id].pheromons_level > 0) return DIR_WEST;
  }
  
  if ( yFarm != HEIGHT-1){
    id = SOUTH_ID(xFarmLocal, yFarmLocal);
    if ( current_cellulae[id].pheromons_level > 0) return DIR_SOUTH;
  }
  return random_dir();
}

enum direction choose_direction_seeking(int x, int y)
{
  enum direction dir = DIR_STAY;
  int id, my_ph;
  double d, d_test;
  int x1;
  
  x1 = x + my_rank * width_info[my_rank];
  
  my_ph = current_cellulae[xyTOid(x, y)].pheromons_level;
  d = distance(xFarm, yFarm, x1, y);
  
  debug( "choose direction seeking farm dist d = %f my_ph = %d ", d, my_ph);   
  
  if east_frontier{
    if (!eastest_rank){
      switch(my_east_cellulae_info[y].type){
      case SOURCE:
	debug (" east source");
	return DIR_EAST;
      case PATH:
	debug("east (%d %d) real (%d %d)  ph_level %d",EAST(x, y), EAST(x1, y), my_east_cellulae_info[y].pheromons_level); 
	if (my_east_cellulae_info[y].pheromons_level != 0) {
	  if (my_ph == 0) {
	    debug("finding phreomons return DIR_EAST"); 
	    return DIR_EAST;
	  }
	  else{ 
	    d_test = distance(xFarm, yFarm, EAST(x1, y) );
	    debug("d = %f  d_test = %f ", d, d_test);  
	    if (d_test>d) {
	      debug("return DIR_EAST");
	      return DIR_EAST;
	    }
	  }
	}
	break;
      case ANTFARM:
	debug ("antfarm");
	break;	
      }
    }
  }
  else {
    id = EAST_ID(x, y);
    switch(current_cellulae[id].type){
    case SOURCE:
      debug (" source");
      return DIR_EAST;
    case PATH:
      debug("east (%d %d) real (%d %d)  ph_level %d",EAST(x, y), EAST(x1, y), current_cellulae[id].pheromons_level); 
      if ( current_cellulae[id].pheromons_level != 0 ){
	if (my_ph == 0) {
	  debug("finding phreomons return DIR_EAST"); 
	  return DIR_EAST;
	}
	else{
	  d_test = distance(xFarm, yFarm, EAST(x1, y) );
	  debug(" d = %f  d_test = %f ", d, d_test);
	  if (d_test>d) {
	    debug("return DIR_EAST");
	    return DIR_EAST;
	  }
	}
      }
      break;
    case ANTFARM:
      debug ("antfarm");
      break;	
    }
  }
  
  if (!north_frontier) {
    id = NORTH_ID(x, y);
    switch(current_cellulae[id].type){
    case SOURCE:
      debug (" north source");
      return DIR_NORTH;
    case PATH:
     debug("north (%d %d) real (%d %d)  ph_level %d",NORTH(x, y), NORTH(x1, y), current_cellulae[id].pheromons_level);  
     if(current_cellulae[id].pheromons_level != 0){
       if ( my_ph == 0 ){
	 debug("finding pheromons return DIR_NORTH");
	 return DIR_NORTH;
       }
       else{
	 d_test = distance(xFarm, yFarm, NORTH(x1, y) );  
	 debug("d = %f  d_test = %f ", d, d_test);
	  if (d_test>d) {
	    debug("return DIR_NORTH");
	    return DIR_NORTH;
	  }
       }
     }
      break;
    case ANTFARM:
      debug ("north antfarm");
      break;	
    }
  }
  
  if west_frontier {
    if (!westest_rank){
      switch(my_west_cellulae_info[y].type){
      case SOURCE:
	debug (" west source");
	return DIR_WEST;
      case PATH:
	debug("west (%d %d) real (%d %d)  ph_level %d",WEST(x, y), WEST(x1, y), my_west_cellulae_info[y].pheromons_level);
	if (my_west_cellulae_info[y].pheromons_level != 0) {
	  if (my_ph == 0){
	    debug("finding pheromons return DIR_WEST");
	    return DIR_WEST;
	  }
	  else{
	    d_test = distance(xFarm, yFarm, WEST(x1, y) );
	    debug("d = %f  d_test=%f ", d, d_test);
	    if (d_test>d) {
	      debug("return DIR_WEST");
	      return DIR_WEST;
	    }
	  }
	}
	break;
      case ANTFARM:
	debug ("west antfarm");
	break;	
      }
    }
  }
  else
    {
      id = WEST_ID(x, y);
      switch(current_cellulae[id].type){
      case SOURCE:
	debug (" west source");
	return DIR_WEST;
      case PATH:
	debug("west (%d %d) real (%d %d)  ph_level %d",WEST(x, y), WEST(x1, y), current_cellulae[id].pheromons_level);
	if (current_cellulae[id].pheromons_level != 0) {
	  if ( my_ph == 0) {  
	    debug("finding pheromons return DIR_WEST");
	    return DIR_WEST;
	  }
	  else{
	    d_test = distance(xFarm, yFarm, WEST(x1, y) );  
	    debug("d = %f  d_test=%f", d, d_test);
	    if (d_test>d) {
	      debug("return DIR_WEST");
	      return DIR_WEST;
	    }
	  }
	}
	break;
      case ANTFARM:
	debug ("west antfarm");
	break;	
      }
    }
  
  if (!south_frontier)
    {
      id = SOUTH_ID(x, y);
      switch(current_cellulae[id].type){
      case SOURCE:
	debug (" south source");
	return DIR_SOUTH;
      case PATH:
	debug("south (%d %d) real (%d %d)  ph_level %d",SOUTH(x, y), SOUTH(x1, y), current_cellulae[id].pheromons_level);
	if (current_cellulae[id].pheromons_level != 0) {
	  if ( my_ph == 0) {  
	    debug("finding pheromons return DIR_SOUTH");
	    return DIR_SOUTH;
	  }
	  else{
	    d_test = distance(xFarm, yFarm, SOUTH(x1, y) );  
	    debug("d = %f  d_test=%f", d, d_test);
	    if (d_test > d) {
	      debug("return DIR_SOUTH");
	      return DIR_SOUTH;
	    }
	  }
	}
	break;
      case ANTFARM:
	debug ("south antfarm");
	break;	
      }  
    }
  
  if( dir != DIR_STAY )
    return dir;
  
  debug("random dir");
  dir = random_dir();
  if ( (south_frontier) && (dir == DIR_SOUTH) ) return DIR_NORTH;
  if ( (north_frontier) && (dir == DIR_NORTH) ) return DIR_SOUTH;
  if ( (east_frontier) && (eastest_rank) && (dir == DIR_EAST) ) return DIR_WEST;
  if ( (west_frontier) && (westest_rank) && (dir == DIR_WEST) ) return DIR_EAST;
  return dir;
}

int pheromons_addition(int l)
{
  debug("pheromons addition");
  if (l + 3*WIDTH >255) {
    return 255;
  }
  else{
    return l + 3 * WIDTH;
  }
}

void algo_path(int x, int y)
{
  int i, id;
  enum direction dir;
  id = xyTOid(x, y);

  for(i = 0; i < current_cellulae[id].ant_loaded; i++)
    {
      debug("PATH: (%d, %d) ant going home (add pheromons)", x, y);
      next_cellulae[id].pheromons_level = pheromons_addition(next_cellulae[id].pheromons_level);
      //current_cellulae[id].pheromons_level = next_cellulae[id].pheromons_level;
      back_home(x, y);
    }

  for(i = 0; i < current_cellulae[id].ant_seeking; i++)
    {
      debug("PATH: (%d %d) ...", x, y);
      dir = choose_direction_seeking(x, y);
      move_ant(x, y, dir, 0);
    }

  if( current_cellulae[id].pheromons_level > 0 )
    {
      next_cellulae[id].pheromons_level = pheromons_evaporation(next_cellulae[id].pheromons_level);
      debug("PATH   (%d, %d)                  pheromons value %d ", x, y, next_cellulae[id].pheromons_level);
    }
}

void algo_source(int x, int y)
{
  int i, id;
  id = xyTOid(x, y);
  
  if(current_cellulae[id].ant_seeking == 0){
    next_cellulae[id].type = SOURCE; 
    next_cellulae[id].amount = current_cellulae[id].amount;
  }
  else {
    for(i = 0; i < current_cellulae[id].ant_seeking; i++)
      {
	debug(" Source (%d %d) loose 1 unity  %d ", x, y, next_cellulae[id].amount - 1);
	next_cellulae[id].amount--;
	back_home(x, y);
	if( next_cellulae[id].amount == 0 )
	  {
	    debug("SOURCE becomes PATH");
	    next_cellulae[id].type = PATH;
	    break;
	  }
      }
  }
}

void algo_antfarm(int x, int y)
{
  int i, id, loaded_ant_at_home;
  id = xyTOid(x, y);
  debug(" (%d %d) case ANTFARM seek: %d load: %d ", x, y, current_cellulae[id].ant_seeking, current_cellulae[id].ant_loaded);
  
  for(i = 0; i < current_cellulae[id].ant_seeking; i++) {
    move_ant(x, y, ant_out_antfarm(x, y), 0);
  }
  
  loaded_ant_at_home = current_cellulae[id].ant_loaded;
  if (loaded_ant_at_home != 0){
    debug ("ant in ANTFARM UNLOAD IT : %d ", loaded_ant_at_home);
    for(i = 0; i < loaded_ant_at_home; i++){
      move_ant(x, y, ant_out_antfarm(x, y), 0);
    }
  }
}

void algo(int x, int y)
{
  switch( next_cellulae[xyTOid(x, y)].type )
    {
    case ANTFARM:
      algo_antfarm(x, y);
      break;
    case SOURCE:
      algo_source(x, y);
      break;
    case PATH:
      algo_path(x, y);
      break;
    }
}

void init_farm_location(void) 
{
  xFarm = XFARM_GLOBAL;
  yFarm = YFARM_GLOBAL;
  if ( xFarm >= width_info[my_rank] && ( (my_rank == comm_size) || (xFarm < width_info[my_rank+1]) ) )
  {
    printf("Farm is on proc %d (%d, %d)\n", my_rank, xFarm, yFarm);
    next_cellulae[xyTOid(xFarm - width_info[my_rank], yFarm)].type = ANTFARM;
    next_cellulae[xyTOid(xFarm - width_info[my_rank], yFarm)].ant_seeking = ANT_QUANTITY;
    ants_by_process = ANT_QUANTITY;
    debug("ants_by_process = %d",ants_by_process);
  }
  else {
    ants_by_process = 0;
    debug("ants_by_process = %d",ants_by_process);
  }
  debug(" xFarm --------- (%d %d)", xFarm, yFarm); 

  
}

void init_source_location(void)
{
  int xSource;
  int ySource;

  //Generate a source location Be careful with processors number 
  if( XSOURCE_GLOBAL >= width_info[my_rank] && 
      ( (eastest_rank) || (XSOURCE_GLOBAL < width_info[my_west_rank]) ) )
    {
      xSource = XSOURCE_GLOBAL - width_info[my_rank];
      ySource = YSOURCE_GLOBAL;
      printf("source is at %d, %d on proc %d at %d, %d\n", XSOURCE_GLOBAL, YSOURCE_GLOBAL, my_rank, xSource, ySource);
      next_cellulae[xyTOid(xSource, ySource)].type = SOURCE;
      next_cellulae[xyTOid(xSource, ySource)].amount = SOURCE_QUANTITY;
    }
}
